-- eigener Held, mit unit-Zuordnung
-- StartTurnAction; Count=1
function CreateHero(unit_id)
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Jacopo_FastRebase"
	hero.extra_traits = {UnitTrait.FastRebase}
	hero.unit_classes = {UnitClass.Fighter}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)

	local assign_hero_action = world:MakeAssignHeroAction(world:GetUnit(unit_id), hero.id)
	world:Exec(assign_hero_action)

--	TutorialMessage("Jäger-Held wurde geliefert.")
end

function Held()
	CreateHero(4)
end


-- neue Einheit erzeugen und platzieren + Ausgabe Nachricht
-- StartTurnAction; Count=1
function Einheit()
	local feld = {37,13}				-- Ort
	local einheit = "Re2000"			-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)	-- welcher Spieler? (hier: 1.Spieler)
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)
-- Parameter von MakePurchaseAction: Spieler, Einheit, Transporter, berstrke
	create_action.auxiliary = false
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	if (hex:GetUnit(0) == nil) then		-- prfen, ob Hex frei ist
		deploy_action = world:MakeDeployAction(unit,feld)
		world:Exec(deploy_action)
	end

	TutorialMessage("Re.2000 wurde geliefert.")
end


-- Depot erobern
-- ntig im Editor unter Trigger:
-- Count: 0
-- Condition kann leer bleiben
-- Actions: CaptureFlagAction
-- Function: OnCaptureDepot

Depot = {{28,2}}
string = "General, wir haben das Ausrüstungslager erobert."
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		Einheit()
		TutorialMessage(string)					
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end

-- die hierfr ntigen Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end


function Runde()			-- Bedingung im Editor: Trigger Rundenanfang
	return world.round == 3
end

function Nachricht()
	MessageBox("Wichtig", "Sie müssen alle Ziele sichern, weil die Abessienen für ihre Angriffe aus dem Hinterhalt bekannt sind!")
end
