-- eigener Held, ohne Zuordnung
-- StartTurnAction; Count=1
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Federico_ExpertSupport"
	hero.extra_traits = {UnitTrait.ExpertSupport}
	hero.unit_classes = {UnitClass.AntiAir}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- neue Einheiten (mit Erfahrung) erzeugen und platzieren (ohne berprfung, ob Felder frei sind) + Ausgabe Nachricht
-- StartTurnAction; Count=1
function Schiffe()
	local player = world:GetPlayer(0)	-- welcher Spieler? (hier: 1.Spieler)

	local feld = {2,47}				-- Ort
	local einheit = "BBLittorio"		-- ID der Einheit, siehe erste Spalte in Units.csv
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)	-- Spieler, Einheit, Transporter, berstrke
	create_action.auxiliary = false		-- Kerneinheit
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 200

	local feld = {3,47}
	local einheit = "CLCondottieri"
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)
	create_action.auxiliary = false
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 400

	local feld = {3,46}
	local einheit = "DDNavigatori"
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)
	create_action.auxiliary = false
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 600

	local feld = {7,44}
	local einheit = "SSMarcello"
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)
	create_action.auxiliary = false
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 700

	MessageBox("", "Vier Schiffe wurden Ihrer Kernarmee zugeordnet.")
end


normal_wave_turns = {2}

-- *** Hex zones ***
-- Spawn zones
sr_spawn_zoneS = {{19,48},{19,47},{20,48},{20,47},{21,48},{1,46},{2,46},{1,47},{2,47},{1,48},{2,48}}

-- Each unit set is a list of blocks in the following format: { "<Unit ID>", "<Transport ID>", overstrength, experience }
sr_wave1 = { {"Bf109B", "", 0, 500}, {"Ju86", "", 0, 500}, {"Ju52Bomber", "", 0, 950}, {"Ju87A", "", 0, 0}, {"Bf110A", "", 0, 0}, {"Fi156Storch", "", 0, 950}, {"He112", "", 0, 950}, {"He123", "", 0, 950} }

-- There can be any number of waves in this list, the game will pick a random one every time
sr_waves = {sr_wave1}

-- There can be any number of zones in this list, the game will pick a random one every time
sr_zones = {sr_spawn_zoneS}

function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)
	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(1) == nil then break end -- found (GetUnit(1) prft ob das Hexfeld in der Luft frei ist)
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = true
		create_action.cost = 0 -- don't take money for units we generate
		create_action.faction = owner.factions[1]  --set to first faction of owning player for created units
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
	end
end

function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- count=0, AlwaysTrue, Actions=NewRoundAction
function OnNewRound()
	-- On the first call, initialize the random generator
	if world.round == 1 then
		math.randomseed(world.seed)
	end

	-- Do we need to spawn a normal wave?
	local is_normal_wave = IsItemInTable(normal_wave_turns, world.round)

	-- If we don't need to spawn any waves this turn then just finish
	if not is_normal_wave then return end

	-- Determine the player to get the next wave
	player = 0

	-- Determine the right zone and units to spawn
	local zone
	local units

	zone = sr_zones[ math.random( #sr_zones ) ] -- random normal SR zone
	units = sr_waves[ math.random( #sr_waves ) ] -- random normal SR wave

	-- Now spawn this wave!
	SpawnWave(player, zone, units)
	MessageBox("Endlich!", "Die Legion Condor schickt uns ihre Flugzeuge als Verstärkung")					
end
