-- eigener Held, ohne Zuordnung
-- StartTurnAction; Count=1
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Lorenzo_LethalAttack"
	hero.extra_traits = {UnitTrait.LethalAttack}
	hero.unit_classes = {UnitClass.StrategicBomber}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- Wenn Spieler Depot erobert, Strkepunkte als "captured" zuweisen
-- ntig im Editor unter Trigger:
-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot

Depot = {{7,10}}	-- auch mehrere Depots mglich
string = "General, wir haben ein Ausrüstungslager erobert."

-- In diese Tabelle werden alle eroberten Depots eingetragen, damit man den Bonus nur bei der 1. Eroberung erhllt
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end	    -- Abfrage ob Depot bereits erobert ist
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then    -- nur ausfhren, wenn Spieler (player0) Depot erobert
		AddEquipment(0, "CharB1", 25, captured)
		AddEquipment(0, "SomuaS35", 20, captured)
		AddEquipment(0, "Panhard178", 20, captured)
		TutorialMessage(string)					
		table.insert(captured_depots, action.flag)		-- Merken, dass das Depot erobert wurde
	else
		return
	end
end

-- die 3 hierfr ntigen Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end


-- Nachschub-KI Einheiten erhalten einen Angriffs-Befehl
-- Count=1, Condition=Runde, Action=EndTurnAction, Function=Angriff
zone = { {1,6},{2,6},{1,7},{2,7},{2,8},{1,9},{17,7},{18,7} }

function Runde()
	return world.round == 11	-- wird eine Runde frher ausgefhrt
end

function SetOrder(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone, u.position)) then			
			local orders = u.orders

			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde (Wirkung in Runde 11)
function Angriff()
	MessageBox("Warnung", "Weitere Feinde greifen an.")
	SetOrder("AIOrderAttacker")
end


-- BB Littorio hochrsten (in Werft in {15,34})
hex = {{15,34}}

function updateBB()
	for id,u in pairs(world.units) do	-- alle Einheiten werden anscheinend 2* durchlaufen
		if (u.type == GetUnitType("BBLittorio") and IsItemInTable(hex, u.position)) then
			u.type = GetUnitType("BBIta40")		-- eigentlicher Update (funktioniert nicht)

			local p = world:GetPlayer(0)
			p.prestige = p.prestige - 20		-- 20 Prestige werden abgezogen

			MessageBox("Hinweis", "Schlachtschiff wurde hochgerüstet.")
		end
	end
end
