-- StartTurnAction; Count=1; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Giuseppe_IgnoresEntrenchment"
	hero.extra_traits = {UnitTrait.IgnoresEntrenchment}
	hero.attack_modifiers = {{type = TargetType.Naval, mod = 1}}
	hero.unit_classes = {UnitClass.Artillery}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{6,24}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "MatildaII", 10, captured)
		AddEquipment(0, "CruiserMkIV", 15, captured)
		AddEquipment(0, "40mmSPAA", 5, captured)
		AddEquipment(0, "BL7-2inch", 20, captured)
		TutorialMessage("General, wir haben ein britisches Depot erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnLager
Lager = {{11,21}}

function OnLager(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Lager, action.flag)) then

		-- Einheit erzeugen und platzieren
		local feld = {10,21}				-- Ort
		local einheit = "SaharanInf"		-- ID der Einheit, siehe erste Spalte in Units.csv
		local player = world:GetPlayer(0)	-- welcher Spieler? (hier: 1.Spieler)
		local create_action = world:MakePurchaseAction(player, einheit, "", 4)	-- Einkauf welcher Einheit?
		-- Parameter von MakePurchaseAction: Spieler, Einheit, Transporter, berstrke
		create_action.auxiliary = true		-- Hilfs- oder Kerneinheit?
		create_action.cost = 0			-- Preis
		world:Exec(create_action)
		local unit = world:GetUnit(create_action.id)
		local hex = world:GetHex(feld)		-- welches Hex?
		if (hex:GetUnit(0) == nil) then		-- prfen, ob keine Bodeneinheit im Hex ist
			deploy_action = world:MakeDeployAction(unit,feld)
			world:Exec(deploy_action)
			unit.experience = 2000
		end

		TutorialMessage("General, wir haben das Gefangenenlager erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

-- die 3 hierfr ntigen Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end


-- Count=1, Condition=Runde, Action=EndTurnAction, Function=Angriff
-- Hilfsprogramme IsItemInTable und FindItemInTable hierfr ntig
zone = { {1,8},{1,10},{1,12},{1,21},{1,22},{1,23} }

function Runde()
	return world.round == 5	-- wird eine Runde frher ausgefhrt
end

function SetOrder(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone, u.position)) then			
			local orders = u.orders

			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff()
	MessageBox("Warnung", "Weitere Feinde greifen an.")
	SetOrder("AIOrderAttacker")
end
