-- Count=1 ; StartTurnAction ; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Samuele_CripplingBlow"
	hero.extra_traits = {UnitTrait.CripplingBlow}
	hero.attack_modifiers = {{type = TargetType.Naval, mod = 1}}
	hero.unit_classes = {UnitClass.Submarine}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end


-- Count=1, Condition=Runde, Action=EndTurnAction, Function=Angriff
zone = { {24,42},{23,42},{22,42},{15,42},{14,42},{32,42} }

function Runde()
	return world.round == 6	-- wird eine Runde frher ausgefhrt
end

function SetOrder(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff()
	SetOrder("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count=1, Condition=Runde2, Action=EndTurnAction, Function=Angriff2
zone2 = { {4,23},{7,23},{8,24},{8,23},{12,23},{15,21},{16,22},{14,17},{18,17},{19,17},{20,17},{22,19},{23,18},{24,12},{23,11},{24,11},{25,11},{24,10},{25,10},{26,10},{28,12},{29,12},{27,13},{28,13},{28,26},{3,24},{1,24},{2,26} }

function Runde2()
	return world.round == 9	-- wird eine Runde frher ausgefhrt
end

function SetOrder2(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone2, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff2()
	SetOrder2("AIOrderAttacker")
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{12,31}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "CrusaderMkII", 20, captured)
		AddEquipment(0, "CrusaderMkIII", 20, captured)
		AddEquipment(0, "ValentineIII", 20, captured)
		AddEquipment(0, "40mmSPAA", 10, captured)
		AddEquipment(0, "SpitfireMkVB", 15, captured)
		TutorialMessage("General, wir haben ein britisches Depot erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end
