-- Count=1 ; StartTurnAction ; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Inf_FastDeployment"
	hero.extra_traits = {UnitTrait.FastDeployment}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Count=1, Condition=Runde, Action=EndTurnAction, Function=Angriff
zone = { {25,31},{26,31},{25,20},{24,21},{25,21},{14,42},{25,22} }

function Runde()
	return world.round == 4	-- wird eine Runde frher ausgefhrt
end

function SetOrder(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff()
	SetOrder("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{16,17}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "ChurchillMkII", 20, captured)
		AddEquipment(0, "SpitfireMkIX", 25, captured)
		AddEquipment(0, "WellingtonMkIII", 20, captured)
		TutorialMessage("General, wir haben einen britischen Hangar erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end
