-- Count=1 ; StartTurnAction ; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "StraBo_EntKiller4"
	hero.extra_traits = {UnitTrait.EntKiller4}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- wegen Bug deutschen Trger verwendet
-- Count=1 ; StartTurnAction ; Einheit
-- Einheit erzeugen und platzieren (ohne berprfung, ob Feld frei ist)
function Einheit()
	local feld = {19,1}			-- Ort
	local einheit = "CVGrafZeppelin"		-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "", 0)
	create_action.auxiliary = false
	create_action.cost = 0
	world:Exec(create_action)

	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.name = "CV Italia"
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Count=1, Condition=Runde, Action=EndTurnAction, Function=Angriff
zone = { {8,34},{9,34},{9,33},{10,34},{10,33},{11,34},{11,33},{12,34},{12,33},{13,32},{13,34},{13,33},{8,32},{8,31} }

function Runde()
	return world.round == 7	-- wird eine Runde frher ausgefhrt
end

function SetOrder(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff()
	SetOrder("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{13,21}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "CrusaderMkIII", 5, captured)
		AddEquipment(0, "ChurchillMkII", 5, captured)
		AddEquipment(0, "BL7-2inch", 5, captured)
		AddEquipment(0, "SpitfireMkVB", 5, captured)
		AddEquipment(0, "StirlingMkI", 20, captured)
		TutorialMessage("General, wir haben ein britisches Nachschublager erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end


function B1()
	return world.round == 2	-- wird eine Runde frher ausgefhrt
end

function Nachricht()
	MessageBox("Nachricht","Der Botschafter in Istanbul meldet, dass eine russische Flottille ins Mittelmeer eingelaufen ist. Was wohl ihr Ziel ist?")
end


-- Count=1, Condition='leer', ObjectiveStatusAction, Function=OnObj1 (2.Ziel)
function OnObj1(action)
	if (action.side == 0 and action.objective == 1 and action.status == ObjectiveStatus.Success) then
		local p = world:GetPlayer(0)
		p.prestige = p.prestige + 400
		TutorialMessage("Sie erhalten 400 Prestige für die Versenkung der feindlichen Flotte.")					
	end
end
