-- Count=1 ; StartTurnAction ; CreateHero
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "AT_NoRetaliation"
	hero.extra_traits = {UnitTrait.NoRetaliation}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Count=1, Condition=Runde1, Action=EndTurnAction, Function=Angriff1
zone1 = { {25,1},{26,1},{31,1},{34,2},{1,75},{2,75},{5,74},{26,65},{20,75},{21,75},{23,75},{24,75},{25,75},{26,75},{27,75},{28,75} }

function Runde1()
	return world.round == 5	-- wird eine Runde frher ausgefhrt
end

function SetOrder1(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone1, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff1()
	SetOrder1("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- alle KI Einheiten erhalten einen Angriffs-Befehl
-- Count=1 Condition=Runde2 Action=EndTurnAction Function=Angriff2
function Runde2()
	return world.round == 14	-- wird eine Runde frher ausgefhrt
end

function SetOrder2(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff2()
	SetOrder2("AIOrderAttacker")
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{2,67}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "ChurchillMkIV", 15, captured)
		AddEquipment(0, "ValentineIV", 15, captured)
		AddEquipment(0, "SpitfireMkIX", 20, captured)
		AddEquipment(0, "BeaufighterMkIF", 20, captured)
		AddEquipment(0, "LancasterMkI", 20, captured)
		TutorialMessage("General, wir haben ein britisches Nachschublager erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end
