-- Count=1 ; StartTurnAction ; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "AT_NoRetaliation"
	hero.extra_traits = {UnitTrait.NoRetaliation}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- 3 Gefangenenlager befreien (Count=0, CaptureFlagAction)
-- In diese Tabelle werden alle eroberten Lager eingetragen, damit man den Bonus nur bei der 1. Eroberung erhllt
captured_lager = {}

Lager1 = {{7,35}}
Lager2 = {{20,22}}
Lager3 = {{34,34}}

function OnCaptureLager1(action)
	if IsItemInTable(captured_lager, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Lager1, action.flag)) then
		Einheit1()
		TutorialMessage("General, wir haben ein Gefangenenlager erobert.")					
		table.insert(captured_lager, action.flag)
	else
		return
	end
end

-- Einheit erzeugen und platzieren (ohne berprfung, ob Feld frei ist)
function Einheit1()
	local feld = {8,36}			-- Ort
	local einheit = "ITParatroops43"	-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "ITTruck", 1)
	create_action.auxiliary = true
	create_action.cost = 0
	world:Exec(create_action)

	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 1000
end

function OnCaptureLager2(action)
	if IsItemInTable(captured_lager, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Lager2, action.flag)) then
		Einheit2()
		TutorialMessage("General, wir haben ein Gefangenenlager erobert.")					
		table.insert(captured_lager, action.flag)
	else
		return
	end
end

-- Einheit erzeugen und platzieren (ohne berprfung, ob Feld frei ist)
function Einheit2()
	local feld = {20,23}			-- Ort
	local einheit = "Battaglioni42"	-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "ITTruck", 2)
	create_action.auxiliary = true
	create_action.cost = 0
	world:Exec(create_action)

	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 2000
end

function OnCaptureLager3(action)
	if IsItemInTable(captured_lager, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Lager3, action.flag)) then
		Einheit3()
		TutorialMessage("General, wir haben ein Gefangenenlager erobert.")					
		table.insert(captured_lager, action.flag)
	else
		return
	end
end

-- Einheit erzeugen und platzieren (ohne berprfung, ob Feld frei ist)
function Einheit3()
	local feld = {34,35}			-- Ort
	local einheit = "ITHWInf43"	-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "ITTruck", 2)
	create_action.auxiliary = true
	create_action.cost = 0
	world:Exec(create_action)

	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	deploy_action = world:MakeDeployAction(unit,feld)
	world:Exec(deploy_action)
	unit.experience = 2000
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Count=1, Condition=Runde1, Action=EndTurnAction, Function=Angriff1
zone1 = { {20,43},{21,43},{35,46},{37,46},{29,14},{29,15},{25,7},{23,9},{15,5},{17,10},{17,11} }

function Runde1()
	return world.round == 6	-- wird eine Runde frher ausgefhrt
end

function SetOrder1(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone1, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff1()
	SetOrder1("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count=1, Condition=Runde2, Action=EndTurnAction, Function=Angriff2
zone2 = { {1,47},{2,46},{2,47},{36,46},{35,47},{36,47},{11,29},{12,30} }

function Runde2()
	return world.round == 10	-- wird eine Runde frher ausgefhrt
end

function SetOrder2(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone2, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff2()
	SetOrder2("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{28,24}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "ChurchillMkIV", 20, captured)
		AddEquipment(0, "ValentineIV", 20, captured)
		AddEquipment(0, "40mmSPAA", 5, captured)
		AddEquipment(0, "SpitfireMkIX", 5, captured)
		TutorialMessage("General, wir haben ein britisches Nachschublager erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end
