-- Count=1 ; StartTurnAction ; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Flak_LearnerAir"
	hero.extra_traits = {UnitTrait.FastLearner}
	hero.attack_modifiers = {{type = TargetType.Air, mod = 1}}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Count=1, Condition=Runde1, Action=EndTurnAction, Function=Angriff1
zone1 = { {3,48},{2,47},{5,47},{4,46},{3,44},{7,7},{42,31},{47,31},{16,34},{15,33},{43,38},{42,37},{43,37},{44,36},{44,35},{44,34},{45,34} }

function Runde1()
	return world.round == 8	-- wird eine Runde frher ausgefhrt
end

function SetOrder1(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone1, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff1()
	SetOrder1("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count=1, Condition=Runde2, Action=EndTurnAction, Function=Angriff2
zone2 = { {5,15},{5,14},{6,14},{5,13},{6,13},{5,12},{6,12},{4,11},{5,11},{6,7},{6,6},{3,6},{4,5},{4,4},{5,4},{4,3},{5,3},{8,2},{10,2} }

function Runde2()
	return world.round == 14	-- wird eine Runde frher ausgefhrt
end

function SetOrder2(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone2, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff2()
	SetOrder2("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count: 0 ; Actions: CaptureFlagAction ; Function: OnCaptureDepot
Depot = {{33,32}}
captured_depots = {}

function OnCaptureDepot(action)
	if IsItemInTable(captured_depots, action.flag) then return end
	if (action.new_owner == 0 and IsItemInTable(Depot, action.flag)) then
		AddEquipment(0, "ShermanFirefly", 20, captured)
		AddEquipment(0, "SpitfireMkXIV", 20, captured)
		AddEquipment(0, "MosquitoMkVI", 20, captured)
		AddEquipment(0, "LancasterMkIII", 20, captured)
		TutorialMessage("General, wir haben ein britisches Nachschublager erobert.")					
		table.insert(captured_depots, action.flag)
	else
		return
	end
end

function AddEquipment(player_id, unit_type, quantity, category)
	local player = world:GetPlayer(player_id)
	local equipment = player.equipment
	local type = GetUnitType(unit_type)
	local eq = equipment[type]
	if (eq == nil) then
		eq = NewEquipment()
		eq.category = category
		equipment[type] = eq
	end
	eq.quantity = eq.quantity + quantity
	player.equipment = equipment
end


-- count=0, AlwaysTrue, Actions=NewRoundAction, Function=OnNewRound
-- Feinde tauchen im Osten auf
normal_wave_turns = {3}

-- *** Hex zones ***
-- Spawn zones
-- When spawning a set of units, the script will scan spawn zones hex by hex, in the order specified, and spawn units in free hexes it finds
-- If the script runs out of hexes, the remainder of the units will not be spawned.
sr_spawn_zoneS = {{49,46},{48,47},{50,46},{49,47},{49,48},{48,48},{48,49},{47,49},{48,50},{50,47},{50,48},{49,49}}

-- *** Enemy waves ***
-- Each unit set is a list of blocks in the following format: { "<Unit ID>", "<Transport ID>", overstrength, experience }

sr_wave1 = { {"USAirborne43", "", 0, 1000}, {"USAirborne43", "", 0, 1000}, {"USAirborne43", "", 0, 1000}, {"75mmM1A1", "", 0, 1000}, {"USAirborne43", "", 0, 1000} }

sr_waves = {sr_wave1}
sr_zones = {sr_spawn_zoneS}

function SpawnWave(player, zone, units)
	local owner = world:GetPlayer(player)
	local cur_hex = 1

	-- Iterate through all units and spawn each one
	for _,u in ipairs(units) do
		-- Find the next vacant hex in the zone
		while zone[cur_hex] do
			hex = world:GetHex(zone[cur_hex])
			if hex:GetUnit(0) == nil then break end -- found
			cur_hex = cur_hex + 1
		end

		-- If we have run out of hexes in the zone, stop
		if not zone[cur_hex] then return end

		-- Create the unit in the free hex we've found
		-- 1. Create and execute purchase action, use unit type, transport type and overstrength as parameters
		local create_action = world:MakePurchaseAction(owner, u[1], u[2], u[3])
		create_action.auxiliary = false -- spawn core units
		create_action.cost = 0 -- don't take money for units we generate
		create_action.faction = owner.factions[1]  --set to first faction of owning player for created units
		world:Exec(create_action)

		-- 2. Create and execute deploy action, place the unit in the hex we've picked.
		local unit = world:GetUnit(create_action.id)
		deploy_action = world:MakeDeployAction(unit, zone[cur_hex])
		world:Exec(deploy_action)

		-- 3. Now modify the unit to set its experience to the value we need.
		unit.experience = u[4]
		
		-- 4. Now modify the unit to set its aggressiveness to the value we need.
		player_aggressiveness = { 10, 10, 10, 10 }
		unit.aggressiveness = player_aggressiveness[player+1]
	end
end

function OnNewRound(action)
	-- On the first call, initialize the random generator
	if world.round == 1 then
		math.randomseed(world.seed)
	end

	-- Do we need to spawn a normal wave?
	local is_normal_wave = IsItemInTable(normal_wave_turns, world.round)

	-- If we don't need to spawn any normal or boss waves this turn then just finish
	if not is_normal_wave then return end

	-- Determine the player to get the next wave
	player = 1

	-- Determine the right zone and units to spawn
	local zone
	local units

	zone = sr_zones[ math.random( #sr_zones ) ] -- random normal SR zone
	units = sr_waves[ math.random( #sr_waves ) ] -- random normal SR wave

	-- Now spawn this wave!
	SpawnWave(player, zone, units)
	MessageBox("Achtung", "Amerikanische Fallschirmjäger wurden in unserem rückwärtigen Raum gesichtet!")					
end
