-- Count=1 ; StartTurnAction ; CreateHero 
function CreateHero()
	local hero = NewHero()
	hero.portrait = "/Game/Gui/Common/Heroes/generic_standin.generic_standin"
	hero.name = "Arti_MachineGun"
	hero.extra_traits = {UnitTrait.MachineGun}
	local action = world:MakeNewHeroAction(0, hero)
	world:Exec(action)
end


-- neue Einheit erzeugen und platzieren + Ausgabe Nachricht
-- count=1 ; Runde ; StartTurnAction ; Einheit
function Runde()
	return world.round == 3
end

function Einheit()
	local feld = {2,4}			-- Ort
	local einheit = "Ar234B"		-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "", 1)
-- Parameter von MakePurchaseAction: Spieler, Einheit, Transporter, berstrke
	create_action.auxiliary = true
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	if (hex:GetUnit(1) == nil) then
		deploy_action = world:MakeDeployAction(unit,feld)
		world:Exec(deploy_action)
		unit.experience = 3000
	end

	local feld = {3,4}			-- Ort
	local einheit = "Me262B"		-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "", 1)
	create_action.auxiliary = true
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	if (hex:GetUnit(1) == nil) then
		deploy_action = world:MakeDeployAction(unit,feld)
		world:Exec(deploy_action)
		unit.experience = 3000
	end

	local feld = {3,3}			-- Ort
	local einheit = "Ta400"		-- ID der Einheit, siehe erste Spalte in Units.csv
	local player = world:GetPlayer(0)
	local create_action = world:MakePurchaseAction(player, einheit, "", 1)
	create_action.auxiliary = true
	create_action.cost = 0
	world:Exec(create_action)
	local unit = world:GetUnit(create_action.id)
	local hex = world:GetHex(feld)
	if (hex:GetUnit(1) == nil) then
		deploy_action = world:MakeDeployAction(unit,feld)
		world:Exec(deploy_action)
		unit.experience = 3000
	end

	MessageBox("", "Deutschland hat drei moderne Staffeln geliefert.")
end


-- Hilfsfunktionen
function FindItemInTable(table, item)
	for index,i in ipairs(table) do
		if i == item then
			return index 
		end
	end
	return -1
end

function IsItemInTable(table, item)
	return FindItemInTable(table, item) ~= -1
end

-- Count=1 Condition=Runde1 Action=EndTurnAction Function=Angriff1
zone1 = { {6,28},{12,30},{12,24},{12,25},{18,20},{21,11},{25,10},{25,9},{30,9},{31,10},{31,9},{30,13},{31,13},{31,14},{31,16},{31,12} }

function Runde1()
	return world.round == 6	-- wird eine Runde frher ausgefhrt
end

function SetOrder1(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone1, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff1()
	SetOrder1("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count=1 Condition=Runde2 Action=EndTurnAction Function=Angriff2
zone2 = { {30,15},{31,21},{31,22},{31,23},{23,18},{17,17},{10,17},{5,18},{4,32},{11,28},{5,38},{10,38},{10,37},{22,33},{27,42},{2,67},{13,65}  }

function Runde2()
	return world.round == 9	-- wird eine Runde frher ausgefhrt
end

function SetOrder2(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone2, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff2()
	SetOrder2("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- Count=1 Condition=Runde3 Action=EndTurnAction Function=Angriff3
zone3 = { {27,61},{26,61},{27,62},{26,62},{26,63},{6,60},{17,48},{23,54},{23,53},{28,48} }

function Runde3()
	return world.round == 12	-- wird eine Runde frher ausgefhrt
end

function SetOrder3(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1 and IsItemInTable(zone3, u.position)) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff3()
	SetOrder3("AIOrderAttacker")
	MessageBox("Warnung", "Weitere Feinde greifen an.")
end


-- alle KI Einheiten erhalten einen Angriffs-Befehl
-- Count=1 Condition=Runde4 Action=EndTurnAction Function=Angriff4
function Runde4()
	return world.round == 16	-- wird eine Runde frher ausgefhrt
end

function SetOrder4(order)
	for id,u in pairs(world.units) do
		if (u.owner_id == 1) then			
			local orders = u.orders
			orders = {NewOrder(order)}
			u.orders = orders
		end
	end
end

-- KI Befehl fr die nchste Runde
function Angriff4()
	SetOrder4("AIOrderAttacker")
end
